"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var METADATA_KEY = 'redux-observable-decorator-metadata';
function Epic() {
    return function (target, propertyName) {
        if (!Reflect.hasOwnMetadata(METADATA_KEY, target)) {
            Reflect.defineMetadata(METADATA_KEY, [], target);
        }
        var epics = Reflect.getOwnMetadata(METADATA_KEY, target);
        var metadata = { propertyName: propertyName };
        Reflect.defineMetadata(METADATA_KEY, epics.concat([metadata]), target);
    };
}
exports.Epic = Epic;
function getEpicsMetadata(instance) {
    var target = Object.getPrototypeOf(instance);
    if (!Reflect.hasOwnMetadata(METADATA_KEY, target)) {
        return [];
    }
    return Reflect.getOwnMetadata(METADATA_KEY, target);
}
exports.getEpicsMetadata = getEpicsMetadata;
function isOptions() {
    var instanceOrOptions = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        instanceOrOptions[_i] = arguments[_i];
    }
    var option = instanceOrOptions[instanceOrOptions.length - 1];
    var keys = option ? Object.keys(option) : [];
    return keys.indexOf('dependencies') >= 0 || keys.indexOf('adapter') >= 0;
}
function createEpics(epic) {
    var epicsOrOptions = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        epicsOrOptions[_i - 1] = arguments[_i];
    }
    var instances;
    var options;
    if (isOptions.apply(void 0, epicsOrOptions)) {
        options = epicsOrOptions.slice(epicsOrOptions.length - 1, epicsOrOptions.length)[0];
    }
    instances = [epic].concat(epicsOrOptions);
    var epicsMetaData = instances
        .map(function (instance) { return getEpicsMetadata(instance)
        .map(function (_a) {
        var propertyName = _a.propertyName;
        return instance[propertyName];
    }); });
    var epics = [].concat.apply([], epicsMetaData);
    return epics;
    // const rootEpic = combineEpics(...epics);
    // return createEpicMiddleware(rootEpic, options);
}
exports.createEpics = createEpics;
