"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var store_1 = require("@angular-redux/store");
var redux_1 = require("redux");
var epic_decorator_1 = require("./epic-decorator");
var router_1 = require("@angular-redux/router");
var redux_observable_1 = require("redux-observable");
exports.storeConfigs = {};
exports.dynamicEpicMiddleware = redux_observable_1.createEpicMiddleware(redux_observable_1.combineEpics.apply(void 0, []));
var StoreConfigService = /** @class */ (function () {
    function StoreConfigService(store) {
        this.store = store;
        this.ActionTypes = {
            ModuleAdd: '[StoreConfig] Module Add'
        };
    }
    StoreConfigService.prototype.addModule = function (moduleName, initialState, reducer, epics) {
        exports.storeConfigs[moduleName] = {
            InitialState: initialState,
            reducer: reducer,
            epics: epics || []
        };
        var newConfig = reigsterModules();
        var newInitialState = newConfig.InitialState;
        var mergedState = __assign({}, this.store.getState(), { newInitialState: newInitialState });
        var newEpic = redux_observable_1.combineEpics.apply(void 0, newConfig.epics);
        exports.dynamicEpicMiddleware.replaceEpic(newEpic);
        this.store.replaceReducer(function (x) { return mergedState; }); // Trivial reducer that just returns the saved state.
        this.store.dispatch({ type: this.ActionTypes.ModuleAdd, payload: moduleName }); // Bogus action to trigger the reducer above.
        this.store.replaceReducer(newConfig.reducer);
    };
    StoreConfigService = __decorate([
        core_1.Injectable(),
        __metadata("design:paramtypes", [store_1.NgRedux])
    ], StoreConfigService);
    return StoreConfigService;
}());
exports.StoreConfigService = StoreConfigService;
function reigsterModules() {
    var items = exports.storeConfigs;
    // Initial State
    var initialState = {};
    var reducerMap = {};
    var epicClasses = [];
    for (var key in items) {
        if (!items.hasOwnProperty(key)) {
            continue;
        }
        initialState[key] = items[key].InitialState;
        reducerMap[key] = items[key].reducer;
        epicClasses.push.apply(epicClasses, items[key].epics);
    }
    // Reducers
    var rootReducer = redux_1.combineReducers(__assign({ router: router_1.routerReducer }, reducerMap));
    // Epics
    var epicInstances = epicClasses;
    // 	.map(x => {
    // 	return injector.get(x);
    // });
    var epics = epicInstances.map(function (x) { return epic_decorator_1.createEpics(x); }).reduce(function (a, b) { return a.concat(b); }, []);
    return {
        InitialState: initialState,
        reducer: rootReducer,
        epics: epics
    };
}
exports.reigsterModules = reigsterModules;
